#include "stdafx.h"
//------------------------------------------------------------------------------
//  nkernel.cc
//  (C) 2002 RadonLabs GmbH
//------------------------------------------------------------------------------
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

//------------------------------------------------------------------------------
/**
    This function is called by n_assert() when the assertion fails.
*/
void
n_barf(const char* exp, const char* file, int line)
{
    n_error("*** NEBULA ASSERTION ***\nexpression: %s\nfile: %s\nline: %d\n", exp, file, line);
}

//------------------------------------------------------------------------------
/**
    This function is called by n_assert2() when the assertion fails.
*/
void
n_barf2(const char* exp, const char* msg, const char* file, int line)
{
    n_error("*** NEBULA ASSERTION ***\nprogrammer says: %s\nexpression: %s\nfile: %s\nline: %d\n", msg, exp, file, line);
}

//------------------------------------------------------------------------------
/**
    This function is called when a serious situation is encountered which
    requires abortion of the program.
*/
void
__cdecl
n_error(const char* msg, ...)
{
    va_list argList;
    va_start(argList, msg);
    vprintf(msg, argList);
    fflush(stdout);
    abort();
};

void
__cdecl
n_printf(const char* msg, ...)
{
    va_list argList;
    va_start(argList,msg);
    vprintf(msg, argList);
    va_end(argList);
}
