// msg.cpp : ܼ  α׷   մϴ.
//

#include "stdafx.h"
#include "message/msg.h"
#include "ptr.h"
#include "Stdafx.h"
#include "msg/MoveGoTo.h"
#include "msg/updatetransform.h"
#include "Factory.h"
#include "game/Entity.h"
#include "Server.h"
#include "game_server.h"
#include "EntityManager.h"
#include "FactoryManager.h"

bool TestEntity()
{
	Managers::FactoryManager* factory = Managers::FactoryManager::Instance();
	if( factory == NULL )
		return false;

	Game::Entity* gameEntity = factory->CreateEntityByClassName("Entity");
	Ptr<Game::Property> component = factory->CreateProperty("TransformableProperty");//factory->CreateProperty("GraphicsProperty");
	gameEntity->AttachProperty(component);

	Ptr<Game::Property> component1 = factory->CreateProperty("GraphicsProperty");
	gameEntity->AttachProperty(component1);

	Managers::EntityManager::Instance()->AttachEntity( gameEntity );

	//Ƽ ϳ ߰
#if  0
	Game::Entity* testEntity = factory->CreateEntityByClassName("Entity");
	Ptr<Game::Property> testComponent = factory->CreateProperty("TransformableProperty");
	testEntity->AttachProperty(testComponent);
	Managers::EntityManager::Instance()->AttachEntity( testEntity );
#endif

#if  0
	//Ptr<Message::MoveGoto> msg = Foundation::Factory<Message::MoveGoto>::Create();
	Ptr<Message::MoveGoto> msg = Message::MoveGoto::Create();
	POINT pt = { 2, 3 };
	msg->SetPosition( pt );
#else
	//Ptr<Message::MoveGoto> moveMsg = Foundation::Factory<Message::MoveGoto>

	Ptr<Message::UpdateTransform> msg = Message::UpdateTransform::Create();
	msg->SetMatrix( matrix44() );
#endif
	
	//===============================================================================================
	// 
	///////////////// Ʒ ޼  θ³Ŀ  ̺Ʈ ȣǴ ̴.
	//
	//===============================================================================================
	//ȭ ޼,  Ʈ ޼ 
#if  1
	gameEntity->SendSync( msg ); 
#endif

	//ȭ ޼, TransformableProperty Ʈ ޼ 
#if  0
	msg->SendSync( component );
#endif

	//񵿱ȭ ޼,  Ʈ ޼ 
#if  0
	gameEntity->SendAsync( msg ); 	
	Managers::EntityManager::Instance()->OnFrame();
#endif

	//񵿱ȭ ޼, TransformableProperty Ʈ ޼ 
#if  0
	msg->SendAsync( component );
	Managers::EntityManager::Instance()->OnFrame();
#endif

#if  0
	//ȭ  ޼ 
	msg->BroadcastSync();
#endif


#if  0
	//񵿱ȭ  ޼ 
	msg->BroadcastAsync();
	Managers::EntityManager::Instance()->OnFrame();
#endif

	return true;
}

int _tmain(int argc, _TCHAR* argv[])
{
	Ptr<Game::Server> gameServer;
	Ptr<Message::Server> messageServer;

	gameServer = Game::Server::Create();
    gameServer->Open();
    messageServer = Message::Server::Create();
    messageServer->Open();

	Ptr<Managers::EntityManager> entityManager = Managers::EntityManager::Create();
	gameServer->AttachManager(entityManager);

	Ptr<Managers::FactoryManager> factoryManager = Managers::FactoryManager::Create();
	gameServer->AttachManager(factoryManager);

	//ID üũ
	const Message::Id& id = Message::MoveGoto::Id;
	if( id == Message::Msg::Id )
		OutputDebugString("true");
	else
		OutputDebugString("false");

	TestEntity();

	//Cleanup
	gameServer->RemoveManager(factoryManager);
	factoryManager = 0;

	entityManager->RemoveAllEntities();
	gameServer->RemoveManager(entityManager);
	entityManager = 0;

    messageServer->Close();
    messageServer = 0;
    gameServer->Close();
    gameServer = 0;
	
	return 0;
}

